//#include "weatherstat.h"
#include "lcd.h"
#include "io430.h"

void Init_LCD(void){
int i;
  P10OUT &= ~LCD_RESET;  //RESET
  for(i=0;i<100;i++);
  P10OUT |= LCD_RESET;
  for(i=0;i<100;i++);

//  LCD_write(DISPLAY_OFF,0);
//  LCD_write(RESET_LCD,0);
//is_busy_LCD();

  LCD_write(LCD_BIAS,0);
  LCD_write(ADC_SEL,0);
//  LCD_write(COMMON_NORMAL,0);
  LCD_write(COMMON_REVERSE,0);
  LCD_write(RES_RATIO,0);
  LCD_write(ELEC_VOL_MODE,0);
//  LCD_write(32,0);
  LCD_write(16,0);
  LCD_write(POWER_CONT,0);
  LCD_write(BOOSTER_MODE_SET,0);
  LCD_write(BOOSTER_RATIO,0);
  LCD_write(ALL_OFF,0);
  LCD_write(DISPLAY_ON,0);
  LCD_write(ALL_OFF,0);
//  LCD_write(ALL_ON,0);
  LCD_clear();
  _NOP();
}


void LCD_write(short val, short adr){

  if(!adr)
        P10OUT &= ~LCD_A0;
  else
        P10OUT |= LCD_A0;

  P10OUT &= ~LCD_CS;
  P10OUT &= ~LCD_WRITE;
  P9OUT = val;
  P10OUT |= LCD_WRITE;
  P10OUT |= LCD_CS;
}

short LCD_read(short adr){
short val;

  if(!adr)
        P10OUT &= ~LCD_A0;
  else
        P10OUT |= LCD_A0;

  P10OUT &= ~LCD_CS;
  P10OUT &= ~LCD_READ;
  val = P9OUT;
  P10OUT |= LCD_READ;
  P10OUT |= LCD_CS;

  return(val);
}
void is_busy_LCD(void){
  short status_reg;

  status_reg= LCD_read(0);

  while(status_reg & 0x80)
    status_reg= LCD_read(0);
  return;
}

void LCD_clear(void){
int row,col;
  for(row=0;row<8;row++){
//    LCD_write(START_LINE+row,0);
    LCD_write(PAGE_ADR+row,0);
//        is_busy_LCD();
    LCD_write(COL_HI_ADR,0);
//            is_busy_LCD();
    LCD_write(COL_LO_ADR,0);
//            is_busy_LCD();
    for(col=0;col<256;col++){
          LCD_write(0,1);
    }
  }
}
void Wrt_to_column(char page, char column, char pattern) //in adressierte Column schreiben (8 bit Pattern)
{
  char column_lsb, column_msb;

  //*** Column in Higher und lower Column zerlegen
  column_lsb=column & 0x0F;
  column_msb=column>>4;

  //*** Page Adress ***
//  wrt_cmd(WRT_PAGE_ADR + page);
//  is_busy_LCD();
  LCD_write(PAGE_ADR + page,0);
		
  //*** Einstellen der Column Adress ***
//  wrt_cmd(WRT_COLUMN_LOW + column_lsb);
//  is_busy_LCD();
  LCD_write(COL_LO_ADR + column_lsb,0);

//  wrt_cmd(WRT_COLUMN_HIGH + column_msb);
//  is_busy_LCD();
  LCD_write(COL_HI_ADR + column_msb,0);

  //*** Daten schreiben *****
//  wrt_data(pattern);
  LCD_write(pattern,1);
}
void Wrt_Char(char page, char column, char character, short reverse) //character ausgeben
{
	char  cnt;

	for(cnt=0; cnt<5; cnt++){
  		if(reverse)
			Wrt_to_column(page, column+cnt,~(FontLookup[character-32][cnt]));  	
		else
			Wrt_to_column(page, column+cnt,FontLookup[character-32][cnt]);
	}
	if(reverse)
		Wrt_to_column(page, column+cnt,0xff);
}

void Wrt_String(char page, char column, char *text, short reverse) //string ausgeben,  Achtung: KEIN Zeilenumbruch
{
	if(reverse)
		Wrt_to_column(page, column-1,0xff);

	while(*text!='\0'){
		Wrt_Char(page, column, *text, reverse);
		column=column+6;
		text++;
	}
}

void Get_Numbers(int val,unsigned short* taus,unsigned short* hun, unsigned short* dec, unsigned short* unit){	
		*taus = val /1000;		
		*hun = (val - (*taus)*1000)/100;
		*dec = (val - (*taus)*1000 - (*hun)*100)/10;
		*unit = (val - (*taus)*1000 - (*hun)*100 - (*dec)*10);
}


void Print_Numbers(char page,char column,int val,short reverse){
unsigned short t,h,z,e;
	Get_Numbers(val,&t, &h, &z, &e);
        column*=6;
	Wrt_Char(page, column, '0'+t, reverse);
	Wrt_Char(page, column+6, '0'+h, reverse);
	Wrt_Char(page, column+12, '0'+z, reverse);
	Wrt_Char(page, column+18, '0'+e, reverse);
}

void _NOP(void){
  int i;
  i+=1;
}




